﻿Public Class StandyHandler

    Private Declare Function SetThreadExecutionState Lib _
    "kernel32" (ByVal esflags As EXECUTION_STATE) As EXECUTION_STATE

    Public Function PreventStandby() As EXECUTION_STATE

        Try
            Return SetThreadExecutionState(EXECUTION_STATE.ES_SYSTEM_REQUIRED Or EXECUTION_STATE.ES_CONTINUOUS Or EXECUTION_STATE.ES_DISPLAY_REQUIRED)
        Catch ex As Exception
            Return SetThreadExecutionState(EXECUTION_STATE.ES_CONTINUOUS)
        End Try

    End Function

End Class


Public Enum EXECUTION_STATE
    ' Stay in working state by resetting display idle timer
    ES_SYSTEM_REQUIRED = &H1
    ' Force display on by resetting system idle timer
    ES_DISPLAY_REQUIRED = &H2
    ' Force this state until next ES_CONTINUOUS call
    ' and one of the other flags are cleared
    ES_CONTINUOUS = &H80000000
End Enum
