﻿Public Class ConnectionInfo

    Private _var_name As String = String.Empty
    Private _var_host As String = String.Empty
    Private _var_port As Integer = 0
    Private _var_path As String = String.Empty
    Private _var_username As String = String.Empty
    Private _var_password As String = String.Empty
    Private _var_auth_required As Boolean = False
    Private _var_connection_type As System.Net.FtpClient.FtpDataConnectionType
    Private _var_data_type As System.Net.FtpClient.FtpDataType
    Private _var_character_encoding As CharacterEncoding.CharacterEncoding
    Private _var_encryption_mode As System.Net.FtpClient.FtpEncryptionMode
    Private _var_list_method As System.Net.FtpClient.FtpListOption
    Private _var_special_character_fix As Boolean = False


    ''' <summary>
    ''' Host/IP-Addresse des FTP-Servers
    ''' </summary>
    Public Property Host As String
        Set(value As String)
            _var_host = value
        End Set
        Get
            Return _var_host
        End Get
    End Property
    ''' <summary>
    ''' Port des FTP-Servers
    ''' </summary>
    Public Property Port As Integer
        Set(value As Integer)
            _var_port = value
        End Set
        Get
            Return _var_port
        End Get
    End Property

    ''' <summary>
    ''' Benutzername zum herstellen der FTP-Verbindung
    ''' </summary>
    Public Property Username As String
        Set(value As String)
            _var_username = value
        End Set
        Get
            Return _var_username
        End Get
    End Property
    ''' <summary>
    ''' Passwort zum herstellen der FTP-Verbindung
    ''' </summary>
    Public Property Password As String
        Set(value As String)
            _var_password = value
        End Set
        Get
            Return _var_password
        End Get
    End Property
    ''' <summary>
    ''' Gibt an ob eine Anmeldung benötigt wird.
    ''' </summary>
    Public Property AuthRequired As Boolean
        Set(value As Boolean)
            _var_auth_required = value
        End Set
        Get
            Return _var_auth_required
        End Get
    End Property
    ''' <summary>
    ''' Gibt an ob welcher TransferModus benutzt wird. (Active or Passive)
    ''' </summary>
    Public Property DataConnectionType As System.Net.FtpClient.FtpDataConnectionType
        Set(value As System.Net.FtpClient.FtpDataConnectionType)
            _var_connection_type = value
        End Set
        Get
            Return _var_connection_type
        End Get
    End Property
    ''' <summary>
    ''' Gibt an ob welcher TransferType benutzt wird. (Binary or ASCII)
    ''' </summary>
    Public Property DataType As System.Net.FtpClient.FtpDataType
        Set(value As System.Net.FtpClient.FtpDataType)
            _var_data_type = value
        End Set
        Get
            Return _var_data_type
        End Get
    End Property
    ''' <summary>
    ''' Gibt an das Encoding an.
    ''' </summary>
    Public Property CharacterEncoding As CharacterEncoding.CharacterEncoding
        Set(value As CharacterEncoding.CharacterEncoding)
            _var_character_encoding = value
        End Set
        Get
            Return _var_character_encoding
        End Get
    End Property
    ''' <summary>
    ''' Gibt an ob und welche Verschlüsselung benutzt wird.
    ''' </summary>
    ''' <remarks>Nicht Implementiert!</remarks>
    Public Property EncryptionMode As System.Net.FtpClient.FtpEncryptionMode
        Set(value As System.Net.FtpClient.FtpEncryptionMode)
            _var_encryption_mode = value
        End Set
        Get
            Return _var_encryption_mode
        End Get
    End Property

    Public Property ListMethod As System.Net.FtpClient.FtpListOption
        Set(value As System.Net.FtpClient.FtpListOption)
            _var_list_method = value
        End Set
        Get
            Return _var_list_method
        End Get
    End Property

    ''' <summary>
    ''' Gibt an ob SpecialCharacterFix genutzt werden soll.
    ''' </summary>
    Public Property UseSpecialCharacterFix As Boolean
        Set(value As Boolean)
            _var_special_character_fix = value
        End Set
        Get
            Return _var_special_character_fix
        End Get
    End Property

End Class
