﻿Imports System.Threading
Imports System.IO
Imports SFDL.Core

Namespace My

    ' Für MyApplication sind folgende Ereignisse verfügbar:
    ' 
    ' Startup: Wird beim Starten der Anwendung noch vor dem Erstellen des Startformulars ausgelöst.
    ' Shutdown: Wird nach dem Schließen aller Anwendungsformulare ausgelöst. Dieses Ereignis wird nicht ausgelöst, wenn die Anwendung nicht normal beendet wird.
    ' UnhandledException: Wird ausgelöst, wenn in der Anwendung eine unbehandelte Ausnahme auftritt.
    ' StartupNextInstance: Wird beim Starten einer Einzelinstanzanwendung ausgelöst, wenn diese bereits aktiv ist. 
    ' NetworkAvailabilityChanged: Wird beim Herstellen oder Trennen der Netzwerkverbindung ausgelöst.
    Partial Friend Class MyApplication

        Private Sub MyApplication_StartupNextInstance(sender As Object, e As ApplicationServices.StartupNextInstanceEventArgs) Handles Me.StartupNextInstance

            For Each _s In e.CommandLine

                Try

                    Dim _file As String = String.Empty

                    If _s.StartsWith("sfdl://") Then

                        _file = ProgressClicknLoadPlugins(_s)

                        If String.IsNullOrEmpty(_file) Then
                            Throw New PluginNotFoundException
                        End If

                        frm_main.OpenSFDLThreadHelper(frm_main.AddTask("Öffne SFDL Datei(en)"), _file)

                    Else

                        If IO.File.Exists(_s) Then
                            'frm_main.tss_status_top.Text = "Öffne SFDL Datei(en)...."
                            'frm_main.tss_progressbar_top.Style = ProgressBarStyle.Marquee
                            frm_main.OpenSFDLThreadHelper(frm_main.AddTask("Öffne SFDL Datei(en)"), _s)
                        End If

                    End If

                Catch ex As PluginNotFoundException

                    MessageBox.Show("ClicknLoad ist fehlgeschlagen da leider kein passendes Plugin gefunden wurde welchen den Hoster unterstützt!", "ClicknLoad Fehler", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

                Catch ex As Exception

                    MessageBox.Show("Fehler" & vbNewLine & "Fehlermeldung: " & ex.Message, "Fehler", MessageBoxButtons.OK, MessageBoxIcon.Error)

                End Try

            Next


        End Sub

    End Class


End Namespace

