﻿Imports SFDL.Loader.OLV_ItemEnums

Public Class Ctr_TabPage

    Private Sub OLV_Package_ItemChecked(sender As Object, e As ItemCheckedEventArgs) Handles OLV_Package.ItemChecked

        Dim _olv_item As OLV_Item = DirectCast(OLV_Package.GetModelObject(e.Item.Index), OLV_Item)
        Dim _sfdl_session As New SFDLSession

        If frm_main.GetDownloadRunning Then

            If _olv_item.Status = Status.Running Then
                e.Item.Checked = _olv_item.Checked
            Else

                If _olv_item.Status = Status.Waiting And _olv_item.Checked = True Then
                    _olv_item.Status = Status.Queued
                    _olv_item.StatusText = String.Empty
                    _olv_item.DownloadSpeed = String.Empty
                    _olv_item.Progress = 0
                    frm_main.RemoveItemFromSizeSpeedCollection(_olv_item)
                End If

                If _olv_item.Status = Status.Queued And _olv_item.Checked = False Then
                    _olv_item.Status = Status.Waiting
                    _olv_item.StatusText = "Warte..."
                    _olv_item.DownloadSpeed = String.Empty
                    _olv_item.Progress = 0
                    frm_main.AddItem2SizeSpeedCollection(_olv_item)

                    Check4NewThreadsTimer.Interval = 500
                    Check4NewThreadsTimer.Enabled = True

                End If

                _olv_item.Checked = e.Item.Checked

            End If

        Else
            _olv_item.Checked = e.Item.Checked

        End If

        _sfdl_session = frm_main.GetSFDLSessionByKey(_olv_item.SFDLSessionName)

        If _olv_item.Checked = True Then
            _sfdl_session.CheckedItems.Add(_olv_item)
        Else
            _sfdl_session.CheckedItems.Remove(_olv_item)
        End If

        frm_main.UpdateSFDLSession(New KeyValuePair(Of String, SFDLSession)(_sfdl_session.SFDLFileName, _sfdl_session))

        Me.OLV_Package.RefreshObject(_olv_item)

    End Sub


    Private Sub Ctr_TabPage_Load(sender As Object, e As EventArgs) Handles Me.Load

        olvc_status.ImageGetter = New BrightIdeasSoftware.ImageGetterDelegate(AddressOf ImageUpdateEventImageGetter)

    End Sub

    Private Function ImageUpdateEventImageGetter(ByVal _row_object As Object) As Object

        Dim _olv_item As New OLV_Item

        _olv_item = DirectCast(_row_object, OLV_Item)

        Select Case _olv_item.Status

            Case Status.Complete

                Return 6

            Case Status.CompleteHashValid

                Return 10

            Case Status.CompleteHashInvalid

                Return 11

            Case Status.FileValdilation

                Return 0

            Case Status.Failure

                Return 5

            Case Status.Waiting

                Return 7

            Case Status.Stopped

                Return 8

            Case Status.Running

                Return 9

            Case Status.Retry

                Return 12

            Case Else

                Return Nothing

        End Select


    End Function


    Private Sub Check4NewThreadsTimer_Tick(sender As Object, e As EventArgs) Handles Check4NewThreadsTimer.Tick
        Check4NewThreadsTimer.Enabled = False

        Dim _thread_handler As New ThreadHandler
        Dim _thread As System.Threading.Thread

        'Prüfen ob neue Threads möglich wären
        _thread = New System.Threading.Thread(Sub() _thread_handler.CheckForNewDownloadThreads())
        _thread.Start()

    End Sub

    Private Sub MarkAllItemsInPackage(sender As Object, e As EventArgs)

        Dim _olv_item As OLV_Item

        If Not OLV_Package.SelectedObjects.Count = 0 Then

            _olv_item = CType(OLV_Package.SelectedObject, OLV_Item)

            For Each _group In OLV_Package.OLVGroups

                If _group.Key.ToString.ToLower.Equals(_olv_item.PackageName.ToLower) Then

                    For Each _item In _group.Items
                        _item.Checked = True
                    Next

                End If

            Next

        End If

    End Sub

    Private Sub DeMarkAllItemsInPackage(sender As Object, e As EventArgs)

        Dim _olv_item As OLV_Item

        If Not OLV_Package.SelectedObjects.Count = 0 Then

            _olv_item = CType(OLV_Package.SelectedObject, OLV_Item)

            For Each _group In OLV_Package.OLVGroups

                If _group.Key.ToString.ToLower.Equals(_olv_item.PackageName.ToLower) Then

                    For Each _item In _group.Items
                        _item.Checked = False
                    Next

                End If

            Next

        End If

    End Sub

    Private Sub ContextMenuMain_Opening(sender As Object, e As System.ComponentModel.CancelEventArgs) Handles ContextMenuMain.Opening

        ContextMenuMain.Items.Clear()

        e.Cancel = False

        For Each _group In OLV_Package.OLVGroups

            Dim _seperator As New ToolStripSeparator

            If Not ContextMenuMain.Items.Count = 0 Then
                ContextMenuMain.Items.Add(_seperator)
            End If

            ContextMenuMain.Items.Add(String.Format("Alle Dateien im Paket {0} makieren", _group.Key.ToString), My.Resources.tick, AddressOf MarkAllItemsInPackage)
            ContextMenuMain.Items.Add(String.Format("Alle Dateien im Paket {0} demakieren", _group.Key.ToString), My.Resources.cross, AddressOf DeMarkAllItemsInPackage)

        Next

        ContextMenuMain.Refresh()

    End Sub
End Class
