﻿Imports SFDL.Core

Public Class frm_pluginmanager

    Dim _logger As New Logger
    Dim _plugin_connector As New Core.PluginConnector
    Dim _tools As New SFDL.Core.Tools

    Private Sub frm_pluginmanager_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        _logger = frm_main.GetLoggerInstance

        _logger.WriteLog("PluginManager", "Lade Plugins....")

        _plugin_connector = frm_main.GetPluginConnectorInstance

        GetPlugins()

        _logger.WriteLog("PluginManager", "Plugins geladen!")

    End Sub


    Private Sub GetPlugins()

        _plugin_connector.LoadPlugins(frm_main.GetPluginsPath)

        Dim _group_active As New ListViewGroup("Aktivierte Plugins", "Aktivierte Plugins")
        Dim _group_disabled As New ListViewGroup("Deaktivierte Plugins", "Deaktivierte Plugins")

        list_plugins.Items.Clear()
        list_plugins.Groups.Clear()

        list_plugins.Groups.Add(_group_active)
        list_plugins.Groups.Add(_group_disabled)

        For Each _plugin In _plugin_connector.Plugins

            Dim _lv_item As New ListViewItem

            _lv_item.UseItemStyleForSubItems = True
            _lv_item.Text = _plugin.GetName
            _lv_item.SubItems.Add(_plugin.GetAuthor)
            _lv_item.SubItems.Add(_plugin.GetVersion.ToString)

            _lv_item.Group = _group_active
            _lv_item.StateImageIndex = 0

            list_plugins.Items.Add(_lv_item)

        Next

        For Each _file In IO.Directory.GetFiles(frm_main.GetPluginsPath, "*.disabled")

            Dim _lv_item As New ListViewItem

            _lv_item.UseItemStyleForSubItems = True
            _lv_item.Text = IO.Path.GetFileNameWithoutExtension(_file)

            _lv_item.Group = _group_disabled
            _lv_item.StateImageIndex = 1

            list_plugins.Items.Add(_lv_item)

        Next


    End Sub

    Private Sub cmd_reload_plugins_Click(sender As Object, e As EventArgs) Handles cmd_reload_plugins.Click
        GetPlugins()
    End Sub


    Private Sub cmd_ok_Click(sender As Object, e As EventArgs) Handles cmd_ok.Click
        Me.Close()
    End Sub

    Private Sub PluginDeakivierenToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles PluginDeakivierenToolStripMenuItem.Click

        For Each _item As ListViewItem In list_plugins.SelectedItems

            If _item.Group.Name = "Aktivierte Plugins" Then
                _plugin_connector.DisablePlugin(_item.Index)
            End If

            If _item.Group.Name = "Deaktivierte Plugins" Then

                Dim _full_path As String = IO.Path.Combine(frm_main.GetPluginsPath, _item.Text & ".disabled")

                If IO.File.Exists(_full_path) Then
                    IO.File.Move(_full_path, _full_path.Replace(".disabled", ""))
                End If

            End If

        Next

        GetPlugins()

    End Sub

End Class