﻿Imports SFDL.Core
Public Class frm_settings

    Private _logger As New Logger
    Protected Friend Event SettingsUpdated(ByVal _new_settings As Settings)
    Public Event SaveSettings()

    Private Sub cmd_choose_download_dir_Click(sender As Object, e As EventArgs) Handles cmd_choose_download_dir.Click

        If Not FBD_Download_Dir.ShowDialog = Windows.Forms.DialogResult.Cancel Then
            txt_download_dir.Text = FBD_Download_Dir.SelectedPath
        End If

    End Sub

    Private Sub cmd_save_settings_Click(sender As Object, e As EventArgs) Handles cmd_save_settings.Click

        Dim _tools As New Tools
        Dim _settings As New Settings
        Dim _unrar_pwd_list As New List(Of String)

        Try

            _settings.DownloadDirectory = txt_download_dir.Text

            If ComB_Existing_File_Handling.SelectedIndex = 0 Then
                _settings.ExistingFileHandling = ExistingFileHandling.ResumeFile
            End If

            If ComB_Existing_File_Handling.SelectedIndex = 1 Then
                _settings.ExistingFileHandling = ExistingFileHandling.OverwriteFile
            End If

            _settings.Send2Tray = chk_send2tray.Checked

            _settings.UpdateCheck = chk_update_check.Checked

            _settings.PreventStandby = chk_prevent_standby.Checked

            _settings.CreateDownloadDir = chk_create_sub_folder.Checked
            _settings.CreateDownloadDirUseDescription = rd_sub_folder_description.Checked
            _settings.CreateDownloadDirUseFilename = rd_sub_folder_filename.Checked
            _settings.MaxDownloadThreads = CInt(num_max_threads.Value)
            _settings.MaxRetry = CInt(num_max_retries.Value)
            _settings.MarkAllContainerFiles = chk_mark_all_files.Checked
            
            _settings.ClicknLoadEnabled = chk_clicknload.Checked


            'Plugin Einstellungen speichern
            For Each _plugin In frm_main.GetPluginConnectorInstance.Plugins

                If _plugin.HasSettings = True Then
                    _plugin.SaveSettings()
                End If

            Next

            _tools.XMLSerialize(_settings, frm_main.GetSettingsPath)

            RaiseEvent SettingsUpdated(_settings)

            _logger.WriteLog("Form Settings", "Einstellungen gespeichert!")

            MessageBox.Show("Einstellungen erfolgreich gespeichert!", "Einstellungen gespeichert", MessageBoxButtons.OK, MessageBoxIcon.Information)

            Me.Close()

        Catch ex As Exception
            _logger.WriteLog("Form Settings", ex.Message, LogType.Fehler)
            MessageBox.Show("Fehler beim speichern der Einstellungen!" & vbNewLine & "Fehler: " & ex.Message, "Fehler", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    Private Sub frm_settings_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        Dim _settings As New Settings
        Dim _tools As New Tools

        Try

            _logger = frm_main.GetLoggerInstance

            _settings = frm_main.GetSettings

            _logger.WriteLog("Form Settings", "Lade Einstellungen...")

            txt_download_dir.Text = _settings.DownloadDirectory

            If _settings.ExistingFileHandling = ExistingFileHandling.ResumeFile Then
                ComB_Existing_File_Handling.SelectedIndex = 0
            End If

            If _settings.ExistingFileHandling = ExistingFileHandling.OverwriteFile Then
                ComB_Existing_File_Handling.SelectedIndex = 1
            End If

            chk_send2tray.Checked = _settings.Send2Tray

            chk_update_check.Checked = _settings.UpdateCheck

            chk_prevent_standby.Checked = _settings.PreventStandby

            chk_create_sub_folder.Checked = _settings.CreateDownloadDir
            rd_sub_folder_description.Checked = _settings.CreateDownloadDirUseDescription
            rd_sub_folder_filename.Checked = _settings.CreateDownloadDirUseFilename

            If _settings.CreateDownloadDirUseDescription = False And _settings.CreateDownloadDirUseFilename = False Then
                rd_sub_folder_filename.Checked = True
            End If

            If _settings.MaxDownloadThreads = 0 Then
                num_max_threads.Value = 1
            Else
                num_max_threads.Value = _settings.MaxDownloadThreads
            End If

            num_max_retries.Value = _settings.MaxRetry

            chk_clicknload.Checked = _settings.ClicknLoadEnabled

            chk_mark_all_files.Checked = _settings.MarkAllContainerFiles

            _logger.WriteLog("Form Settings", "Einstellungen geladen!")

            _logger.WriteLog("Form Settings", "Lade Plugin Einstellungen...")


            For Each _plugin In frm_main.GetPluginConnectorInstance.Plugins
                TabControlMain_Settings.TabPages.RemoveByKey(_plugin.GetName)
            Next

            'Plugin Einstellungen laden
            For Each _plugin In frm_main.GetPluginConnectorInstance.Plugins

                If _plugin.HasSettings = True Then

                    Dim _user_control As New UserControl

                    _user_control = _plugin.GetSettingsTab

                    _user_control.Dock = DockStyle.Fill

                    TabControlMain_Settings.TabPages.Add(_plugin.GetName, _plugin.GetSettingsTabName)

                    TabControlMain_Settings.TabPages(TabControlMain_Settings.TabCount - 1).Controls.Add(_user_control)
                    TabControlMain_Settings.TabPages(TabControlMain_Settings.TabCount - 1).ImageIndex = 0

                End If

            Next

            _logger.WriteLog("Form Settings", "Plugin Einstellungen geladen")

        Catch ex As Exception
            MessageBox.Show(ex.Message, Application.ProductName, MessageBoxButtons.OK, MessageBoxIcon.Warning)
            _logger.WriteLog("Form Settings", ex.Message, LogType.Fehler)
        End Try

    End Sub

    Private Sub cmd_choose_download_dir_Click_1(sender As Object, e As EventArgs)

        If Not FBD_Download_Dir.ShowDialog = Windows.Forms.DialogResult.Cancel Then
            txt_download_dir.Text = FBD_Download_Dir.SelectedPath
        End If

    End Sub

    Private Sub chk_create_sub_folder_CheckedChanged(sender As Object, e As EventArgs) Handles chk_create_sub_folder.CheckedChanged
        If chk_create_sub_folder.Checked Then
            rd_sub_folder_description.Enabled = True
            rd_sub_folder_filename.Enabled = True
        Else
            rd_sub_folder_description.Enabled = False
            rd_sub_folder_filename.Enabled = False
        End If
    End Sub


End Class