﻿Imports System.Windows.Forms
Imports SFDL.Loader
Imports System.ComponentModel.Composition

<Export(GetType(PluginInterface.PluginInterface.SFDLLoaderPlugin))>
Public Class SpeedreportPlugin

    Implements PluginInterface.PluginInterface.SFDLLoaderPlugin

    Dim _tools As New SFDL.Core.Tools

    Private Shared _sfdl_main_form As New SFDL.Loader.frm_main
    Private Shared _settings As New SpeedreportSettings
    Private Shared _settings_path As String = IO.Path.Combine(IO.Path.GetDirectoryName(_sfdl_main_form.GetSettingsPath), "settings_speedreportplugin.xml")
    Private Shared _settings_tab As New tab_speedreport_setting
    Private Shared _sfdl_session As SFDL.Loader.SFDLSession

#Region "Properties"

    Protected Friend ReadOnly Property GetLoaderSettings As SFDL.Loader.Settings
        Get
            Return _sfdl_main_form.GetSettings
        End Get
    End Property

    Protected Friend ReadOnly Property GetSpeedreportSettings As SpeedreportSettings
        Get
            Return _settings
        End Get
    End Property

    Protected Friend ReadOnly Property GetSFDLSession As SFDL.Loader.SFDLSession
        Get
            Return _sfdl_session
        End Get
    End Property

#End Region

    Public Function ClicknLoadDownloadSFDL(_url As String) As String Implements PluginInterface.PluginInterface.SFDLLoaderPlugin.ClicknLoadDownloadSFDL
        Throw New NotImplementedException
    End Function

    Public Function ClicknLoadSupportedHosts() As List(Of String) Implements PluginInterface.PluginInterface.SFDLLoaderPlugin.ClicknLoadSupportedHosts
        Throw New NotImplementedException
    End Function

    Public Function ClicknLoadURLSupported(_url As String) As Boolean Implements PluginInterface.PluginInterface.SFDLLoaderPlugin.ClicknLoadURLSupported
        Throw New NotImplementedException
    End Function

    Public Function GetAuthor() As String Implements PluginInterface.PluginInterface.SFDLLoaderPlugin.GetAuthor
        Return "Seji"
    End Function

    Public Function GetName() As String Implements PluginInterface.PluginInterface.SFDLLoaderPlugin.GetName
        Return "Speedreport Plugin"
    End Function

    Public Function GetPlatfomCompatibility() As PluginInterface.PluginInterface.Platform Implements PluginInterface.PluginInterface.SFDLLoaderPlugin.GetPlatfomCompatibility
        Return PluginInterface.PluginInterface.Platform.Multi
    End Function

    Public Function GetVersion() As String Implements PluginInterface.PluginInterface.SFDLLoaderPlugin.GetVersion
        Return "0.3"
    End Function

    Public Function HasSettings() As Boolean Implements PluginInterface.PluginInterface.SFDLLoaderPlugin.HasSettings
        Return True
    End Function

    Public Sub Load() Implements PluginInterface.PluginInterface.SFDLLoaderPlugin.Load

        If IO.File.Exists(_settings_path) Then

            _settings = CType(_tools.XMLDeSerialize(_settings, _settings_path), SpeedreportSettings)

            _settings_tab.chk_show_speedreport.Checked = _settings.ShowSpeedreportAfterDownload
            _settings_tab.txt_speed_var_username.Text = _settings.SpeedreportUsername
            _settings_tab.txt_speed_var_connection.Text = _settings.SpeedreportConnection
            _settings_tab.txt_speed_var_comment.Text = _settings.SpeedreportComment
            _settings_tab.rtb_speedreport.Text = _settings.SpeedreportTemplate

            If String.IsNullOrWhiteSpace(_settings.SpeedreportTemplate) Then
                _settings.SpeedreportTemplate = My.Settings.Default_Speedreport
                _settings_tab.rtb_speedreport.Text = My.Settings.Default_Speedreport
            End If

        Else
            _settings.SpeedreportTemplate = My.Settings.Default_Speedreport
        End If


    End Sub


    Public Function GetSettingsTab() As Windows.Forms.UserControl Implements PluginInterface.PluginInterface.SFDLLoaderPlugin.GetSettingsTab
        Return _settings_tab
    End Function

    Public Function GetSettingsTabName() As String Implements PluginInterface.PluginInterface.SFDLLoaderPlugin.GetSettingsTabName
        Return "Speedreport Einstellungen"
    End Function

    Public Sub SaveSettings() Implements PluginInterface.PluginInterface.SFDLLoaderPlugin.SaveSettings

        _settings.ShowSpeedreportAfterDownload = _settings_tab.chk_show_speedreport.Checked
        _settings.SpeedreportUsername = _settings_tab.txt_speed_var_username.Text
        _settings.SpeedreportConnection = _settings_tab.txt_speed_var_connection.Text
        _settings.SpeedreportComment = _settings_tab.txt_speed_var_comment.Text
        _settings.SpeedreportTemplate = _settings_tab.rtb_speedreport.Text

        _tools.XMLSerialize(_settings, IO.Path.Combine(IO.Path.GetDirectoryName(_sfdl_main_form.GetSettingsPath), "settings_speedreportplugin.xml"))

    End Sub

    Public Function GetCommandButtonName() As String Implements PluginInterface.PluginInterface.SFDLLoaderPlugin.GetCommandButtonName
        Throw New NotImplementedException
    End Function

    Public Sub CommandButtonEvent(sender As Object, e As EventArgs) Implements PluginInterface.PluginInterface.SFDLLoaderPlugin.CommandButtonEvent
        Throw New NotImplementedException
    End Sub

    Private Sub DownloadSessionCompleteEvent(_session As Loader.SFDLSession, _has_downloaded_files As Boolean)

        Dim _frm_speedreport As New frm_speedreport
        Dim _rt As New PluginInterface.PluginReturnInfo

        _sfdl_session = _session

        If _settings.ShowSpeedreportAfterDownload = True And _has_downloaded_files = True Then
            _frm_speedreport.ShowDialog()
        End If


    End Sub

    Public Sub PostItemDownload(_item As Object, _session_uid As String, _event_type As Object) Implements PluginInterface.PluginInterface.SFDLLoaderPlugin.PostItemDownload

    End Sub

    Public Sub PostSessionDownload(_session As Object, _has_downloaded_files As Boolean) Implements PluginInterface.PluginInterface.SFDLLoaderPlugin.PostSessionDownload

        Dim _frm_speedreport As New frm_speedreport
        Dim _rt As New PluginInterface.PluginReturnInfo

        _sfdl_session = CType(_session, SFDLSession)

        If _settings.ShowSpeedreportAfterDownload = True And _has_downloaded_files = True Then
            _frm_speedreport.ShowDialog()
        End If


    End Sub

    Public Function SpecialPluginFunctions() As List(Of PluginInterface.PluginInterface.SpeicalPluginFunction) Implements PluginInterface.PluginInterface.SFDLLoaderPlugin.SpecialPluginFunctions

        Dim _rt As New List(Of PluginInterface.PluginInterface.SpeicalPluginFunction)

        _rt.Add(PluginInterface.PluginInterface.SpeicalPluginFunction.PostSessionDownload)

        Return _rt

    End Function
End Class
