﻿Imports SFDL.Core
Imports System.Windows.Forms

Public Class frm_speedreport

    Dim _settings As New SpeedreportSettings
    Dim _plugin As New SpeedreportPlugin

    Private Sub cmd_OK_Click(sender As Object, e As EventArgs) Handles cmd_OK.Click
        Me.Close()
    End Sub

    Private Sub frm_speedreport_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        Dim _tools As New Tools
        Dim _speed As Double
        Dim _size As Double
        Dim _sfdl_session As SFDL.Loader.SFDLSession

        Try

            _settings = _plugin.GetSpeedreportSettings
            _sfdl_session = _plugin.GetSFDLSession

            _speed = CalculateSpeed(_sfdl_session.TimeDownloadStarted, _sfdl_session.TimeDownloadStopped, _sfdl_session.CheckedItems)
            _size = CalculateSizeAsMB(_sfdl_session.CheckedItems)

            rtb_speedreport.Text = _settings.SpeedreportTemplate

            'Variablen ersetzten
            rtb_speedreport.Text = rtb_speedreport.Text.Replace("%%USER%%", _settings.SpeedreportUsername)
            rtb_speedreport.Text = rtb_speedreport.Text.Replace("%%CONNECTION%%", _settings.SpeedreportConnection)
            rtb_speedreport.Text = rtb_speedreport.Text.Replace("%%COMMENT%%", _settings.SpeedreportComment)
            rtb_speedreport.Text = rtb_speedreport.Text.Replace("%%SPEED%%", Math.Round(_speed, 2) & " KB/s")
            rtb_speedreport.Text = rtb_speedreport.Text.Replace("%%SFDL_DESC%%", _sfdl_session.SFDLFile.Description)
            rtb_speedreport.Text = rtb_speedreport.Text.Replace("%%SFDL_UPPER%%", _sfdl_session.SFDLFile.Uploader)
            rtb_speedreport.Text = rtb_speedreport.Text.Replace("%%TIME%%", _tools.SecToHMS(DateDiff(DateInterval.Second, _sfdl_session.TimeDownloadStarted, _sfdl_session.TimeDownloadStopped)))
            rtb_speedreport.Text = rtb_speedreport.Text.Replace("%%SFDL_SIZE%%", Math.Round(_size, 2) & " MB")

        Catch ex As Exception
            MessageBox.Show("Speedreport konnte nicht angezeigt werden!", "Sorry", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try


    End Sub

    Private Function CalculateSizeAsMB(ByVal _item_list As List(Of SFDL.Loader.OLV_Item)) As Double

        Dim _full_session_size As Double

        For Each _file In _item_list
            _full_session_size += _file.FileSize
        Next

        _full_session_size = (_full_session_size / 1024) / 1024

        Return _full_session_size

    End Function

    Private Function CalculateSpeed(ByVal _starttime As Date, ByVal _stoptime As Date, ByVal _item_list As List(Of SFDL.Loader.OLV_Item)) As Double

        Dim _full_session_size As Double
        Dim _time_elapsed As Double
        Dim _rt As Double


        For Each _file In _item_list
            _full_session_size += _file.FileSize
        Next

        _full_session_size = _full_session_size / 1024

        _time_elapsed = DateDiff(DateInterval.Second, _starttime, _stoptime)

        Debug.WriteLine(String.Format("{0} KB in {1} Sekunden heruntergeladen", _full_session_size, _time_elapsed))

        _rt = _full_session_size / _time_elapsed

        Return _rt


    End Function

    Private Sub LinkExplorer_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles LinkExplorer.LinkClicked

        Dim _tools As New Tools
        Dim _loader_settings As New SFDL.Loader.Settings

        _loader_settings = _plugin.GetLoaderSettings

        Try
            _tools.OpenExplorer(_loader_settings.DownloadDirectory)
        Catch ex As Exception
            MessageBox.Show("Verzeichniss konnte nicht geöffnet werden!", "Sorry...", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub
End Class