﻿Imports SFDL.Loader
Imports System.ComponentModel.Composition
Imports RARNET

<Export(GetType(PluginInterface.PluginInterface.SFDLLoaderPlugin))>
Public Class UnRARPlugin

    Implements PluginInterface.PluginInterface.SFDLLoaderPlugin

    Private Shared _settings_tab As New tab_unrar_setting
    Private Shared _sfdl_main_form As SFDL.Loader.frm_main
    Private Shared _tools As New SFDL.Core.Tools
    Private Shared _unrar_settings As New UnRARSettings
    Private Shared _settings_path As String

    Private Shared _unrar As Decompressor

    Public Function ClicknLoadDownloadSFDL(_url As String) As String Implements PluginInterface.PluginInterface.SFDLLoaderPlugin.ClicknLoadDownloadSFDL
        Throw New NotImplementedException
    End Function

    Public Function ClicknLoadSupportedHosts() As List(Of String) Implements PluginInterface.PluginInterface.SFDLLoaderPlugin.ClicknLoadSupportedHosts
        Throw New NotImplementedException
    End Function

    Public Function ClicknLoadURLSupported(_url As String) As Boolean Implements PluginInterface.PluginInterface.SFDLLoaderPlugin.ClicknLoadURLSupported
        Throw New NotImplementedException
    End Function

    Public Sub CommandButtonEvent(sender As Object, e As EventArgs) Implements PluginInterface.PluginInterface.SFDLLoaderPlugin.CommandButtonEvent

    End Sub

    Public Function GetAuthor() As String Implements PluginInterface.PluginInterface.SFDLLoaderPlugin.GetAuthor
        Return "Seji"
    End Function

    Public Function GetCommandButtonName() As String Implements PluginInterface.PluginInterface.SFDLLoaderPlugin.GetCommandButtonName
        Return "Dateien entpacken"
    End Function

    Public Function GetName() As String Implements PluginInterface.PluginInterface.SFDLLoaderPlugin.GetName
        Return "UnRAR Plugin"
    End Function

    Public Function GetPlatfomCompatibility() As PluginInterface.PluginInterface.Platform Implements PluginInterface.PluginInterface.SFDLLoaderPlugin.GetPlatfomCompatibility
        Return PluginInterface.PluginInterface.Platform.Windows
    End Function

    Public Function GetSettingsTab() As System.Windows.Forms.UserControl Implements PluginInterface.PluginInterface.SFDLLoaderPlugin.GetSettingsTab
        Return _settings_tab
    End Function

    Public Function GetSettingsTabName() As String Implements PluginInterface.PluginInterface.SFDLLoaderPlugin.GetSettingsTabName
        Return "UnRAR Einstellungen"
    End Function

    Public Function GetVersion() As String Implements PluginInterface.PluginInterface.SFDLLoaderPlugin.GetVersion
        Return "0.1"
    End Function

    Public Function HasSettings() As Boolean Implements PluginInterface.PluginInterface.SFDLLoaderPlugin.HasSettings
        Return True
    End Function

    Public Sub Load() Implements PluginInterface.PluginInterface.SFDLLoaderPlugin.Load

        _sfdl_main_form = New SFDL.Loader.frm_main

        _settings_path = IO.Path.Combine(IO.Path.GetDirectoryName(_sfdl_main_form.GetSettingsPath), "settings_unrarplugin.xml")

        If IO.File.Exists(_settings_path) Then

            _unrar_settings = CType(_tools.XMLDeSerialize(_unrar_settings, _settings_path), UnRARSettings)

            _settings_tab.chk_unrar_pwd_list.Checked = _unrar_settings.UseUnRARPasswordList
            _settings_tab.chk_unrar_auto.Checked = _unrar_settings.UnRARAfterDownload
            _settings_tab.chk_unrar_del_files.Checked = _unrar_settings.DeleteAfterUnRAR

            _settings_tab.ListUnRARPwd.Items.Clear()

            For Each _pwd In _unrar_settings.UnRARPasswordList
                _settings_tab.ListUnRARPwd.Items.Add(_pwd)
            Next

        Else
            _settings_tab.chk_unrar_auto.Checked = True
        End If

    End Sub

    Public Sub SaveSettings() Implements PluginInterface.PluginInterface.SFDLLoaderPlugin.SaveSettings

        Dim _unrar_settings As New UnRARSettings
        Dim _unrar_pwd_list As New List(Of String)
        Dim _tools As New SFDL.Core.Tools

        'UnRAR Settings
        _unrar_settings.DeleteAfterUnRAR = _settings_tab.chk_unrar_del_files.Checked
        _unrar_settings.UnRARAfterDownload = _settings_tab.chk_unrar_auto.Checked
        _unrar_settings.UseUnRARPasswordList = _settings_tab.chk_unrar_pwd_list.Checked

        For Each _pwd In _settings_tab.ListUnRARPwd.Items
            _unrar_pwd_list.Add(_pwd.ToString)
        Next

        _unrar_settings.UnRARPasswordList = _unrar_pwd_list

        _tools.XMLSerialize(_unrar_settings, IO.Path.Combine(IO.Path.GetDirectoryName(_sfdl_main_form.GetSettingsPath), "settings_unrarplugin.xml"))

    End Sub

    Public Sub PostItemDownload(_item As Object, _session_uid As String, _event_type As Object) Implements PluginInterface.PluginInterface.SFDLLoaderPlugin.PostItemDownload
        Throw New NotImplementedException
    End Sub


    Public Sub PostSessionDownload(_session As Object, _has_downloaded_files As Boolean) Implements PluginInterface.PluginInterface.SFDLLoaderPlugin.PostSessionDownload

        Dim _sfdl_session As New SFDLSession

        _sfdl_session = TryCast(_session, SFDLSession)

        If _has_downloaded_files = True Then

            Dim _sfdl_main_form As New SFDL.Loader.frm_main





        End If



    End Sub

    Public Function SpecialPluginFunctions() As List(Of PluginInterface.PluginInterface.SpeicalPluginFunction) Implements PluginInterface.PluginInterface.SFDLLoaderPlugin.SpecialPluginFunctions

        Dim _rt As New List(Of PluginInterface.PluginInterface.SpeicalPluginFunction)

        _rt.Add(PluginInterface.PluginInterface.SpeicalPluginFunction.CommandButton)
        _rt.Add(PluginInterface.PluginInterface.SpeicalPluginFunction.PostSessionDownload)

        Return _rt

    End Function
End Class
