﻿Option Strict On

Namespace FTP
    ''' <summary>
    ''' Enumeration representing the three types of actions that FTP supports when
    ''' uploading or 'putting' a file on an FTP server from the FTP client.  
    ''' </summary>
    Public Enum FileAction As Integer
        ''' <summary>
        ''' No action.
        ''' </summary>
        None
        ''' <summary>
        ''' Create a new file or overwrite an existing file.
        ''' </summary>
        Create
        ''' <summary>
        ''' Create a new file.  Do not overwrite an existing file.
        ''' </summary>
        CreateNew
        ''' <summary>
        ''' Create a new file or append an existing file.
        ''' </summary>
        CreateOrAppend
        ''' <summary>
        ''' Resume a file transfer.
        ''' </summary>
        [Resume]
        ''' <summary>
        ''' Resume a file transfer if the file already exists.  Otherwise, create a new file.
        ''' </summary>
        ResumeOrCreate
    End Enum
End Namespace