﻿Option Strict On

Namespace FTP
    ''' <summary>
    ''' FTP server commands.
    ''' </summary>
    Public Enum FtpCmd
        ''' <summary>
        ''' Unknown command issued.
        ''' </summary>
        Unknown
        ''' <summary>
        ''' The USER command.
        ''' </summary>
        User
        ''' <summary>
        ''' The PASS command.
        ''' </summary>
        Pass
        ''' <summary>
        ''' The MKD command.  Make new directory.
        ''' </summary>
        Mkd
        ''' <summary>
        ''' The RMD command.  Remove directory.
        ''' </summary>
        Rmd
        ''' <summary>
        ''' The RETR command.  Retrieve file.
        ''' </summary>
        Retr
        ''' <summary>
        ''' The PWD command.  Print working directory.
        ''' </summary>
        Pwd
        ''' <summary>
        ''' The SYST command.  System status.
        ''' </summary>
        Syst
        ''' <summary>
        ''' The CDUP command.  Change directory up.
        ''' </summary>
        Cdup
        ''' <summary>
        ''' The DELE command.  Delete file or directory.
        ''' </summary>
        Dele
        ''' <summary>
        ''' The TYPE command.  Transfer type.
        ''' </summary>
        Type
        ''' <summary>
        ''' The CWD command.  Change working directory.
        ''' </summary>
        Cwd
        ''' <summary>
        ''' The PORT command.  Data port.
        ''' </summary>
        Port
        ''' <summary>
        ''' The PASV command.  Passive port.
        ''' </summary>
        Pasv
        ''' <summary>
        ''' The STOR command.  Store file.
        ''' </summary>
        Stor
        ''' <summary>
        ''' The STOU command.  Store file unique.
        ''' </summary>
        Stou
        ''' <summary>
        ''' The APPE command.  Append file.
        ''' </summary>
        Appe
        ''' <summary>
        ''' The RNFR command.  Rename file from.
        ''' </summary>
        Rnfr
        ''' <summary>
        ''' The RFTO command.  Rename file to.
        ''' </summary>
        Rnto
        ''' <summary>
        ''' The ABOR command.  Abort current operation.
        ''' </summary>
        Abor
        ''' <summary>
        ''' The LIST command.  List files.
        ''' </summary>
        List
        ''' <summary>
        ''' The NLST command.  Namelist files.
        ''' </summary>
        Nlst
        ''' <summary>
        ''' The SITE command.  Site.
        ''' </summary>
        Site
        ''' <summary>
        ''' The STAT command.  Status.
        ''' </summary>
        Stat
        ''' <summary> 
        ''' The NOOP command.  No operation.
        ''' </summary>
        Noop
        ''' <summary>
        ''' The HELP command.  Help.
        ''' </summary>
        Help
        ''' <summary>
        ''' The ALLO command.  Allocate space.
        ''' </summary>
        Allo
        ''' <summary>
        ''' The QUIT command.  Quite session.
        ''' </summary>
        Quit
        ''' <summary>
        ''' The REST command.  Restart transfer.
        ''' </summary>
        Rest
        ''' <summary>
        ''' The AUTH command.  Initialize authentication.
        ''' </summary>
        Auth
        ''' <summary>
        ''' The PBSZ command.
        ''' </summary>
        Pbsz
        ''' <summary>
        ''' The PROT command.  Security protocol.
        ''' </summary>
        Prot
        ''' <summary>
        ''' The MODE command.  Data transfer mode.
        ''' </summary>
        Mode
        ''' <summary>
        ''' The MDTM command.  Month, date, and time.
        ''' </summary>
        Mdtm
        ''' <summary>
        ''' The SIZE command.  File size.
        ''' </summary>
        Size
        ''' <summary>
        ''' The FEAT command.  Supported features.
        ''' </summary>
        Feat
        ''' <summary>
        ''' The XCRC command.  CRC file integrity.
        ''' </summary>
        Xcrc
        ''' <summary>
        ''' The XMD5 command.  MD5 file integrity.
        ''' </summary>
        Xmd5
        ''' <summary>
        ''' The XSHA1 command.  SHA1 file integerity.
        ''' </summary>
        Xsha1
        ''' <summary>
        ''' The EPSV command.  
        ''' </summary>
        Epsv
        ''' <summary>
        ''' The ERPT command.
        ''' </summary>
        Erpt
    End Enum
End Namespace