﻿Option Strict On

Namespace FTP
    ''' <summary>
    ''' Event arguments to facilitate the FtpClient request event.
    ''' </summary>
    Public Class FtpRequestEventArgs
        Inherits EventArgs
        Private _request As FtpRequest

        ''' <summary>
        ''' Constructor for FtpRequestEventArgs.
        ''' </summary>
        ''' <param name="request">An FtpRequest object.</param>
        Public Sub New(ByVal request As FtpRequest)
            _request = request
        End Sub

        ''' <summary>
        ''' Client request command text sent from the client to the server.
        ''' </summary>
        Public ReadOnly Property Request() As FtpRequest
            Get
                Return _request
            End Get
        End Property
    End Class

End Namespace