﻿Option Strict On

Namespace FTP
    ''' <summary>
    ''' Event arguments to facilitate the response event from the FTP server.
    ''' </summary>
    Public Class FtpResponseEventArgs
        Inherits EventArgs
        Private _response As FtpResponse

        ''' <summary>
        ''' Constructor.
        ''' </summary>
        ''' <param name="response">FtpResponse object.</param>
        Public Sub New(ByVal response As FtpResponse)
            _response = response
        End Sub

        ''' <summary>
        ''' Response object containing response received from the server.
        ''' </summary>
        Public ReadOnly Property Response() As FtpResponse
            Get
                Return _response
            End Get
        End Property
    End Class
End Namespace