﻿Option Strict On

Imports System.ComponentModel

Namespace FTP
    ''' <summary>
    ''' Provides data for the GetDirListAsyncCompleted event.
    ''' </summary>
    Public Class GetDirListAsyncCompletedEventArgs
        Inherits AsyncCompletedEventArgs
        Private _directoryListing As FtpItemCollection

        ''' <summary>
        '''  Initializes a new instance of the PutFileAsyncCompletedEventArgs class.
        ''' </summary>
        ''' <param name="error">Any error that occurred during the asynchronous operation.</param>
        ''' <param name="canceled">A value indicating whether the asynchronous operation was canceled.</param>
        ''' <param name="directoryListing">A FtpItemCollection containing the directory listing.</param>
        Public Sub New(ByVal [error] As Exception, ByVal canceled As Boolean, ByVal directoryListing As FtpItemCollection)
            MyBase.New([error], canceled, Nothing)
            _directoryListing = directoryListing
        End Sub

        ''' <summary>
        ''' Directory listing collection.
        ''' </summary>
        Public ReadOnly Property DirectoryListingResult() As FtpItemCollection
            Get
                'base.RaiseExceptionIfNecessary();
                Return _directoryListing
            End Get
        End Property
    End Class

End Namespace