﻿Option Strict On

Imports System.Runtime.Serialization

Namespace FTP.Exceptions

    ''' <summary>
    ''' This exception is thrown when an exception occurs while opening a connection to the FTP
    ''' server using a proxy.  See the inner exception for more information when this exception is thrown.
    ''' </summary>
    <Serializable()> _
    Public Class FtpProxyException
        Inherits FtpException
        ''' <summary>
        ''' Constructor.
        ''' </summary>
        Public Sub New()
        End Sub

        ''' <summary>
        ''' Constructor.
        ''' </summary>
        ''' <param name="message">Exception message text.</param>
        Public Sub New(ByVal message As String)
            MyBase.New(message)
        End Sub

        ''' <summary>
        ''' Constructor.
        ''' </summary>
        ''' <param name="message">Exception message text.</param>
        ''' <param name="innerException">The inner exception object.</param>
        Public Sub New(ByVal message As String, ByVal innerException As Exception)
            MyBase.New(message, innerException)
        End Sub

        ''' <summary>
        ''' Constructor.
        ''' </summary>
        ''' <param name="info">Serialization information.</param>
        ''' <param name="context">Stream context information.</param>
        Protected Sub New(ByVal info As SerializationInfo, ByVal context As StreamingContext)
            MyBase.New(info, context)
        End Sub

        ''' <summary>
        ''' Constructor.
        ''' </summary>
        ''' <param name="message">Exception message text.</param>
        ''' <param name="response">Ftp response object.</param>
        ''' <param name="innerException">The inner exception object.</param>
        Public Sub New(ByVal message As String, ByVal response As FtpResponse, ByVal innerException As Exception)
            MyBase.New(message, response, innerException)
        End Sub


        ''' <summary>
        ''' Constructor.
        ''' </summary>
        ''' <param name="message">Exception message text.</param>
        ''' <param name="response">Ftp response object.</param>
        Public Sub New(ByVal message As String, ByVal response As FtpResponse)
            MyBase.New(message, response)
        End Sub

    End Class

End Namespace