﻿Option Strict On

Imports System.Runtime.Serialization

Namespace FTP.Exceptions

    ''' <summary>
    ''' This exception is thrown when a file integrity check fails.
    ''' For detailed information about the error, the FTP server response 
    ''' can be inspected via the Reponse property on this exception.
    ''' </summary>
    <Serializable()> _
    Public Class FtpResponseException
        Inherits FtpException
        ''' <summary>
        ''' Constructor.
        ''' </summary>
        Public Sub New()
        End Sub

        ''' <summary>
        ''' Constructor.
        ''' </summary>
        ''' <param name="message">Exception message text.</param>
        ''' <param name="response">Ftp response object.</param>
        Public Sub New(ByVal message As String, ByVal response As FtpResponse)
            MyBase.New(message, response)
        End Sub

        ''' <summary>
        ''' Constructor.
        ''' </summary>
        ''' <param name="response">Ftp response object.</param>
        ''' <param name="message">Exception message text.</param>
        ''' <param name="innerException">The inner exception object.</param>
        Public Sub New(ByVal message As String, ByVal response As FtpResponse, ByVal innerException As Exception)
            MyBase.New(message, response, innerException)
        End Sub

        ''' <summary>
        ''' Constructor.
        ''' </summary>
        ''' <param name="info">Serialization information.</param>
        ''' <param name="context">Stream context information.</param>
        Protected Sub New(ByVal info As SerializationInfo, ByVal context As StreamingContext)
            MyBase.New(info, context)
        End Sub

    End Class

End Namespace