'
' *  Authors:  Benton Stark
' * 
' *  Copyright (c) 2007-2012 Starksoft, LLC (http://www.starksoft.com) 
' *
' * Permission is hereby granted, free of charge, to any person obtaining a copy
' * of this software and associated documentation files (the "Software"), to deal
' * in the Software without restriction, including without limitation the rights
' * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
' * copies of the Software, and to permit persons to whom the Software is
' * furnished to do so, subject to the following conditions:
' * 
' * The above copyright notice and this permission notice shall be included in
' * all copies or substantial portions of the Software.
' * 
' * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
' * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
' * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
' * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
' * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
' * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
' * THE SOFTWARE.
' * 
' 


Imports System.ComponentModel

Namespace FTP
    ''' <summary>
    ''' Provides data for the GetDirListAsyncCompleted event.
    ''' </summary>
    Public Class GetDirListAsyncCompletedEventArgs
        Inherits AsyncCompletedEventArgs
        Private _directoryListing As FtpItemCollection

        ''' <summary>
        '''  Initializes a new instance of the PutFileAsyncCompletedEventArgs class.
        ''' </summary>
        ''' <param name="error">Any error that occurred during the asynchronous operation.</param>
        ''' <param name="canceled">A value indicating whether the asynchronous operation was canceled.</param>
        ''' <param name="directoryListing">A FtpItemCollection containing the directory listing.</param>
        Public Sub New([error] As Exception, canceled As Boolean, directoryListing As FtpItemCollection)
            MyBase.New([error], canceled, Nothing)
            _directoryListing = directoryListing
        End Sub

        ''' <summary>
        ''' Directory listing collection.
        ''' </summary>
        Public ReadOnly Property DirectoryListingResult() As FtpItemCollection
            Get
                'base.RaiseExceptionIfNecessary();
                Return _directoryListing
            End Get
        End Property
    End Class

End Namespace
