﻿Option Strict On

Imports System.Net.Sockets
Imports System.ComponentModel

Namespace Proxy
    ''' <summary>
    ''' Event arguments class for the EncryptAsyncCompleted event.
    ''' </summary>
    Public Class CreateConnectionAsyncCompletedEventArgs
        Inherits AsyncCompletedEventArgs
        Private _proxyConnection As TcpClient

        ''' <summary>
        ''' Constructor.
        ''' </summary>
        ''' <param name="error">Exception information generated by the event.</param>
        ''' <param name="cancelled">Cancelled event flag.  This flag is set to true if the event was cancelled.</param>
        ''' <param name="proxyConnection">Proxy Connection.  The initialized and open TcpClient proxy connection.</param>
        Public Sub New(ByVal [error] As Exception, ByVal cancelled As Boolean, ByVal proxyConnection As TcpClient)
            MyBase.New([error], cancelled, Nothing)
            _proxyConnection = proxyConnection
        End Sub

        ''' <summary>
        ''' The proxy connection.
        ''' </summary>
        Public ReadOnly Property ProxyConnection() As TcpClient
            Get
                Return _proxyConnection
            End Get
        End Property
    End Class

End Namespace
