﻿Option Strict On

Imports System.Runtime.Serialization

Namespace Proxy

    ''' <summary>
    ''' This exception is thrown when a general, unexpected proxy error.   
    ''' </summary>
    <Serializable()> _
    Public Class ProxyException
        Inherits Exception
        ''' <summary>
        ''' Constructor.
        ''' </summary>
        Public Sub New()
        End Sub

        ''' <summary>
        ''' Constructor.
        ''' </summary>
        ''' <param name="message">Exception message text.</param>
        Public Sub New(ByVal message As String)
            MyBase.New(message)
        End Sub

        ''' <summary>
        ''' Constructor.
        ''' </summary>
        ''' <param name="message">Exception message text.</param>
        ''' <param name="innerException">The inner exception object.</param>
        Public Sub New(ByVal message As String, ByVal innerException As Exception)
            MyBase.New(message, innerException)
        End Sub

        ''' <summary>
        ''' Constructor.
        ''' </summary>
        ''' <param name="info">Serialization information.</param>
        ''' <param name="context">Stream context information.</param>
        Protected Sub New(ByVal info As SerializationInfo, ByVal context As StreamingContext)
            MyBase.New(info, context)
        End Sub
    End Class

End Namespace
