'
' *  Authors:  Benton Stark
' * 
' *  Copyright (c) 2007-2012 Starksoft, LLC (http://www.starksoft.com) 
' *
' * Permission is hereby granted, free of charge, to any person obtaining a copy
' * of this software and associated documentation files (the "Software"), to deal
' * in the Software without restriction, including without limitation the rights
' * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
' * copies of the Software, and to permit persons to whom the Software is
' * furnished to do so, subject to the following conditions:
' * 
' * The above copyright notice and this permission notice shall be included in
' * all copies or substantial portions of the Software.
' * 
' * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
' * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
' * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
' * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
' * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
' * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
' * THE SOFTWARE.
' * 
' 


Imports System.Net.Sockets
Imports System.ComponentModel

Namespace Proxy
    ''' <summary>
    ''' Event arguments class for the EncryptAsyncCompleted event.
    ''' </summary>
    Public Class CreateConnectionAsyncCompletedEventArgs
        Inherits AsyncCompletedEventArgs
        Private _proxyConnection As TcpClient

        ''' <summary>
        ''' Constructor.
        ''' </summary>
        ''' <param name="error">Exception information generated by the event.</param>
        ''' <param name="cancelled">Cancelled event flag.  This flag is set to true if the event was cancelled.</param>
        ''' <param name="proxyConnection">Proxy Connection.  The initialized and open TcpClient proxy connection.</param>
        Public Sub New([error] As Exception, cancelled As Boolean, proxyConnection As TcpClient)
            MyBase.New([error], cancelled, Nothing)
            _proxyConnection = proxyConnection
        End Sub

        ''' <summary>
        ''' The proxy connection.
        ''' </summary>
        Public ReadOnly Property ProxyConnection() As TcpClient
            Get
                Return _proxyConnection
            End Get
        End Property
    End Class

End Namespace
